Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clc_core_cp.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clc_core_cp.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clc_core_cp.F90	(revision 4727)
@@ -0,0 +1,232 @@
+!
+! $Id$
+!
+      SUBROUTINE clc_core_cp(du, dt, dq, t1, q1, &
+     				zu, zt, zq, &
+     					P,&
+     				n_it, mixte, &
+    			 coeffs, rugosm, rugosh)
+
+      IMPLICIT NONE
+
+
+  !  INTEGER     :: i,j,k
+  REAL, INTENT(IN) :: du,dt,dq,t1,q1
+  REAL, INTENT(IN) :: zu,zt,zq, P
+  INTEGER, INTENT(IN):: n_it
+  LOGICAL, INTENT(IN) :: mixte
+  REAL, DIMENSION(3), INTENT(OUT) :: coeffs
+  real, intent(out) :: rugosm
+  real, intent(out) :: rugosh
+
+
+!  REAL :: du,dt,t1,dq,q1
+  REAL :: dt_u, dq_u
+
+
+
+  REAL :: cd, ch, cd_rt, cd_n10, ce_n10, ce,&
+       u_N, X,&
+       rho,cpa,le
+
+  REAL :: usr,tsr,qsr
+  REAL, DIMENSION(3) :: zeta                           ! dans l'ordre: it courant, it precedente, var
+  REAL, DIMENSION(2,3) :: psi
+  REAL, PARAMETER :: g = 9.81, k=.41, sqrt_k = .640312 !avec g= gravité, k = cste von karman, sqrt_k = racine(k)
+  REAL :: logzu_10,logzt_10,logzq_10,logzt_zu,logzq_zu,&
+       u,cd_n10_rt,ch_n10_rt,ch_n10,chi,z_0m,z_0h,tv
+  INTEGER :: i,j,m1,m2,m3,m4,m5
+
+
+  REAL :: phih,phid,phie
+
+  
+  REAL, parameter :: alpha=2.7e-3,&           !alpha = a1 ds formulation smith 
+       beta = 1.42e-4,&                       !beta = a2 ds la formulation smith
+       gamma = 7.64e-5,&        !Large and yaeger 2006              !gamma = a3 ds formulation smith
+!       gamma = 13.09e-3,&         !Large and yaeger 2004
+       q0 = 1.64474                           ! q0 dzfinis mais pas reutilisée ds la suite ??
+
+  REAL, dimension(3) :: z
+  integer, dimension(2) :: tmp_shape
+  z = [zu, zt, zq]
+ 
+
+
+  logzu_10 = LOG(zu/10.)
+  logzt_10 = LOG(zt/10.)
+  logzq_10 = LOG(zq/10.)
+  logzt_zu = logzt_10 - logzu_10
+  logzq_zu = logzq_10 - logzu_10
+
+  cpa = 1004.67                               !!! pas reutilise ds nvelle formulation...
+
+  tv = t1 * (1+.608*q1)                       !!!!! tv pas reutiliser ds nvelle formulation...
+  rho = p / (287.1 * t1 * (1.+.61*q1))        !!!! rho pas reutiliser ds nvelle formulation....
+
+
+  le = (2.501-.00237*(t1-273.15-dt))*1.e6     !!!!!! le pas reutiliser ds nvelle formulation....
+  
+  u = max(du,.5)                              !!!! u = vitesse du vent 1 er niveau
+  u_N = u                                     !!!!!!! u_N utilisée pour le calcul des premier calcul...
+  
+
+  !!!!! initialisation des parametres et premier calcul de z_0 cd et ch
+
+
+  if (mixte) then 
+     z_0m = 1.e-4                             !!!!! pour l'initialisation on fixe z_0 a 10-4
+     cd_n10 = k**2 / (log(10/z_0m))**2        !!!!! on calcul ensuite cd a 10 m d'après smith 
+     cd_n10_rt = sqrt(cd_n10)   
+  else
+! Large and yaeger 2006
+     cd_n10 = alpha / u_n + beta + gamma * u_n !!!!! calcul de cd pour core pur
+! Large and yaeger 2004
+!     cd_n10 = 1E-3 * (2.7/U_n + 0.142 + U_n/13.09) 
+     cd_n10_rt = sqrt(cd_n10)                  !!!!!!
+     z_0m = 10. * exp(-k/cd_n10_rt)            !!!!!!! on calcul le premier z_0
+  endif
+
+
+  if ( dt .gt. 0. ) then
+     ch_n10 = 0.018 * cd_n10_rt                !!!!!!! si regime stable calcul du ch
+!     z_0h = 10. * exp(-k/ch_n10)
+  else
+     ch_n10 = 0.0327 * cd_n10_rt               !!!!!!! si regime instable calcul du ch
+!     z_0h = 10. * exp(-k/ch_n10)
+  endif
+
+  ce_n10 = 3.46e-2 *cd_n10_rt                  !!!!!! calcul ensuite de ce
+
+
+  dt_u = dt                                    !!! def
+  dq_u = dq                                    !!! def
+
+  cd = cd_n10                                  !!! def
+  ch = ch_n10                                  !!! def
+  ce = ce_n10                                  !!! def
+
+  cd_rt = sqrt(cd)                             !!! def
+
+  !  open(7,file="err_rel.dat",position="append")
+
+
+!!!!!!!!! début des itérations....
+
+  do i = 1,n_it
+
+     usr = cd_rt * u 
+     tsr = ch / cd_rt *  dt_u
+     qsr = ce / cd_rt * dq_u
+
+
+     zeta = k*g / (usr**2) * tsr / t1&
+          * z
+
+     zeta = sign( min(abs(zeta),10.0), zeta )
+
+
+!!!! calcul du zeta pour connaitre le signe et donc en deduire le regime...
+
+
+
+
+     IF ( zeta(1) .GT. 0 ) THEN !!! si regime stable alors valeurs pr chi et psi 
+
+        chi = 0.018 
+
+
+        psi(1,1) = -5.*zeta(1)
+        psi(2,1) = psi(1,1)
+
+     ELSE !!!!! si regime instable alors valeurs pr psi et chi !!!
+
+        chi = 0.0327
+
+        X = sqrt( sqrt( 1-16.*zeta(1) ))
+        psi(1,1) =  3.1415695 / 2 + 2 * LOG( ( 1 + X ) / 2 ) + LOG( (1 + X**2) / 2 ) - 2*ATAN(X)
+        psi(2,1) =  2.*LOG( (1 + X**2) / 2 )
+
+     END IF
+
+     do j =2,3
+        IF ( zeta(j) .GT. 0 ) THEN
+           psi(1,j) = -5.*zeta(j)
+           psi(2,j) = psi(1,1)
+
+        ELSE
+           X = sqrt( sqrt( 1-16.*zeta(j) ))
+           psi(1,j) =  3.1415695 / 2 + 2 * LOG( ( 1 + X ) / 2 ) + LOG( (1 + X**2) / 2 ) - 2*ATAN(X)
+           psi(2,j) =  2.*LOG( (1 + X**2) / 2 )
+
+        END IF
+     enddo
+
+
+     dt_u = dt - tsr / k * &
+          ( logzt_zu + psi(2,1) - psi(2,2) )
+
+     dq_u = dq - qsr / k * &
+          ( logzq_zu + psi(2,1) - psi(2,3) )
+
+
+
+     u_N = u / ( 1 + cd_n10_rt / k * ( logzu_10 - psi(1,1)) )
+
+     if (mixte) then
+        z_0m=0.018*usr**2/9.81 + 0.11*14e-6 / (usr)
+!        z_0h=(0.11*14e-6 / (usr)) + 1.4e-5 
+        cd_n10 = k**2 / (log(10/z_0m))**2
+        cd_n10_rt = sqrt(cd_n10)
+!        ch_n10 = k**2 / ((log(10/z_0m))*(log(10/z_0h)))
+!        ch_n10_rt = sqrt(ch_n10)
+        ch_n10 = 1.e-3
+     else
+! Large and yaeger 2006
+        cd_n10 = alpha / u_n + beta + gamma * u_n !!!!! calcul de cd pour core pur
+! Large and yaeger 2004
+!        cd_n10 = 1E-3 * (2.7/U_n + 0.142 + U_n/13.09) 
+        !        cd_n10_dun = -alpha / u_n**2 + gamma
+        cd_n10_rt = sqrt(cd_n10)
+        z_0m = 10. * exp(-k/cd_n10_rt) !!!!! c'est sur cette ligne la qu'il y a un bug... ou sur la ligne du u_N
+!        ch_n10 = chi * cd_n10_rt
+!        z_0h = 10. * exp(-k/ch_n10)
+!        ch_n10_rt = sqrt(ch_n10)
+        ch_n10 = chi * cd_n10_rt
+     endif
+
+
+     ce_n10 = 3.46e-2*cd_n10_rt
+
+
+
+     phid = 1+cd_n10_rt/k * (logzu_10 - psi(1,1))
+     phih = 1+chi/k * (logzu_10 - psi(2,1))
+     phie = 1+3.46e-2/k * (logzu_10 - psi(2,1))
+
+
+     cd_rt = cd_n10_rt / abs( phid )
+     ch = ch_n10 / ( phih * phid )
+     ce = ce_n10 / ( phie * phid )
+
+     cd=cd_rt**2
+
+  END DO
+
+  usr = cd_rt * u
+  tsr = ch / cd_rt *  dt_u
+  qsr = ce / cd_rt * dq_u
+
+
+  ! coeffs(:,m) = [ &
+  !      rho * usr**2,&
+  !      rho * cpa * usr *tsr,&
+  !      rho * le * usr *qsr]
+
+  coeffs = [ cd_rt**2, ch , ce ]
+
+  rugosm =  z_0m
+  rugosh =  z_0h
+
+      RETURN
+      END subroutine clc_core_cp
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clesphys.h	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/clesphys.h	(revision 4727)
@@ -18,4 +18,5 @@
        REAL co2_ppm, co2_ppm0, solaire
        INTEGER iflag_thermals,nsplit_thermals
+       INTEGER iflag_physiq
        REAL tau_thermals
 
@@ -42,4 +43,6 @@
 !IM seuils cdrm, cdrh
        REAL cdmmax, cdhmax
+!IM pour les params différentes Olivier Torres
+       INTEGER choix_bulk, nit_bulk, kz0
 !IM param. stabilite s/ terres et en dehors
        REAL ksta, ksta_ter, f_ri_cd_min
@@ -100,8 +103,9 @@
        LOGICAL :: ok_daily_climoz
        LOGICAL :: ok_new_lscp
+       LOGICAL :: ok_bs, ok_rad_bs
 ! flag to bypass or not the phytrac module
        INTEGER :: iflag_phytrac
 
-!AI flags pour ECRAD
+!AI flags pour ECRAD       
        LOGICAL :: ok_3Deffect
        CHARACTER(len=512) :: namelist_ecrad_file
@@ -109,4 +113,5 @@
        COMMON/clesphys/                                                 &
 ! REAL FIRST
+! rajout choix_bulk et nit_bulk kz0 par Olivier Torres
      &       co2_ppm, solaire                                           &
      &     , RCO2, RCH4, RN2O, RCFC11, RCFC12                           &
@@ -136,4 +141,5 @@
      &     , ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad                &
      &     , iflag_con, nbapp_cv, nbapp_wk                              &
+     &     , choix_bulk, nit_bulk, kz0                                  &
      &     , iflag_ener_conserv                                         &
      &     , ok_suntime_rrtm                                            & 
@@ -154,7 +160,7 @@
      &     , ok_chlorophyll,ok_conserv_q, adjust_tropopause             &
      &     , ok_daily_climoz, ok_all_xml, ok_lwoff                      &
-     &     , iflag_phytrac, ok_new_lscp                                 &
-     &     , iflag_thermals,nsplit_thermals, tau_thermals               &
-     &     , ok_3Deffect, namelist_ecrad_file    
+     &     , iflag_phytrac, ok_new_lscp, ok_bs, ok_rad_bs               &
+     &     ,  iflag_thermals,nsplit_thermals, tau_thermals              &
+     &     , iflag_physiq, ok_3Deffect, namelist_ecrad_file
        save /clesphys/
 !$OMP THREADPRIVATE(/clesphys/)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/climb_qbs_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/climb_qbs_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/climb_qbs_mod.F90	(revision 4727)
@@ -0,0 +1,389 @@
+MODULE climb_qbs_mod
+!
+! Module to solve the verctical diffusion of blowing snow; 
+!
+  USE dimphy
+
+  IMPLICIT NONE
+  SAVE 
+  PRIVATE
+  PUBLIC :: climb_qbs_down, climb_qbs_up
+
+  REAL, DIMENSION(:,:), ALLOCATABLE :: gamaqbs
+  !$OMP THREADPRIVATE(gamaqbs)
+  REAL, DIMENSION(:,:), ALLOCATABLE :: Ccoef_QBS, Dcoef_QBS
+  !$OMP THREADPRIVATE(Ccoef_QBS, Dcoef_QBS)
+  REAL, DIMENSION(:), ALLOCATABLE   :: Acoef_QBS, Bcoef_QBS
+  !$OMP THREADPRIVATE(Acoef_QBS, Bcoef_QBS)
+  REAL, DIMENSION(:,:), ALLOCATABLE :: Kcoefqbs
+  !$OMP THREADPRIVATE(Kcoefqbs)
+
+CONTAINS
+!
+!****************************************************************************************
+!
+  SUBROUTINE climb_qbs_down(knon, coefqbs, paprs, pplay, &
+       delp, temp, qbs, dtime, &
+       Ccoef_QBS_out, Dcoef_QBS_out, &
+       Kcoef_qbs_out, gama_qbs_out, &
+       Acoef_QBS_out, Bcoef_QBS_out)
+
+! This routine calculates recursivly the coefficients C and D
+! for the quantity X=[QBS] in equation X(k) = C(k) + D(k)*X(k-1), where k is
+! the index of the vertical layer.
+!
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN)                      :: knon
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: coefqbs
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: pplay 
+    REAL, DIMENSION(klon,klev+1), INTENT(IN) :: paprs 
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: delp  
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: temp
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: qbs
+    REAL, INTENT(IN)                         :: dtime
+
+! Output arguments
+!****************************************************************************************
+    REAL, DIMENSION(klon), INTENT(OUT)       :: Acoef_QBS_out
+    REAL, DIMENSION(klon), INTENT(OUT)       :: Bcoef_QBS_out
+
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: Ccoef_QBS_out
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: Dcoef_QBS_out
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: Kcoef_qbs_out
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: gama_qbs_out
+
+! Local variables
+!****************************************************************************************
+    LOGICAL, SAVE                            :: first=.TRUE.
+    !$OMP THREADPRIVATE(first)
+    REAL, DIMENSION(klon)                    :: psref 
+    REAL                                     :: delz, pkh
+    INTEGER                                  :: k, i, ierr
+! Include
+!****************************************************************************************
+    INCLUDE "YOMCST.h"
+    INCLUDE "compbl.h"    
+
+
+!****************************************************************************************
+! 1)
+! Allocation at first time step only
+!   
+!****************************************************************************************
+
+    IF (first) THEN
+       first=.FALSE.
+       ALLOCATE(Ccoef_QBS(klon,klev), STAT=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in allloc Ccoef_QBS, ierr=', ierr
+       
+       ALLOCATE(Dcoef_QBS(klon,klev), STAT=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in allloc Dcoef_QBS, ierr=', ierr
+       
+       ALLOCATE(Acoef_QBS(klon), Bcoef_QBS(klon), STAT=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in allloc Acoef_BS and Bcoef_BS, ierr=', ierr
+       
+       ALLOCATE(Kcoefqbs(klon,klev), STAT=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in allloc Kcoefqbs, ierr=', ierr
+       
+       ALLOCATE(gamaqbs(1:klon,2:klev), STAT=ierr)
+       IF ( ierr /= 0 ) PRINT*,' pb in allloc gamaqbs, ierr=', ierr
+       
+    END IF
+
+!****************************************************************************************
+! 2)
+! Definition of the coeficient K 
+!
+!****************************************************************************************
+    Kcoefqbs(:,:) = 0.0
+    DO k = 2, klev
+       DO i = 1, knon
+          Kcoefqbs(i,k) = &
+               coefqbs(i,k)*RG*RG*dtime /(pplay(i,k-1)-pplay(i,k)) &
+               *(paprs(i,k)*2/(temp(i,k)+temp(i,k-1))/RD)**2
+       ENDDO
+    ENDDO
+
+!****************************************************************************************
+! 3)
+! Calculation of gama for "Q" and "H"
+!
+!****************************************************************************************
+!   surface pressure is used as reference
+    psref(:) = paprs(:,1) 
+
+!   definition of gama
+    IF (iflag_pbl == 1) THEN
+       gamaqbs(:,:) = 0.0
+ 
+! conversion de gama
+       DO k = 2, klev
+          DO i = 1, knon
+             delz = RD * (temp(i,k-1)+temp(i,k)) / & 
+                    2.0 / RG / paprs(i,k) * (pplay(i,k-1)-pplay(i,k))
+             pkh  = (psref(i)/paprs(i,k))**RKAPPA
+          
+! convertie gradient verticale de contenu en neige soufflee en difference de neige soufflee entre centre de couches
+             gamaqbs(i,k) = gamaqbs(i,k) * delz    
+          ENDDO
+       ENDDO
+
+    ELSE
+       gamaqbs(:,:) = 0.0
+    ENDIF
+    
+
+!****************************************************************************************    
+! 4)
+! Calculte the coefficients C and D for specific content of blowing snow, qbs
+!
+!****************************************************************************************
+    
+    CALL calc_coef_qbs(knon, Kcoefqbs(:,:), gamaqbs(:,:), delp(:,:), qbs(:,:), &
+         Ccoef_QBS(:,:), Dcoef_QBS(:,:), Acoef_QBS, Bcoef_QBS)
+
+ 
+!****************************************************************************************
+! 5)
+! Return the first layer in output variables
+!
+!****************************************************************************************
+    Acoef_QBS_out = Acoef_QBS
+    Bcoef_QBS_out = Bcoef_QBS
+
+!****************************************************************************************
+! 6)
+! If Pbl is split, return also the other layers in output variables
+!
+!****************************************************************************************
+    IF (mod(iflag_pbl_split,10) .ge.1) THEN
+    DO k= 1, klev
+      DO i= 1, klon
+        Ccoef_QBS_out(i,k) = Ccoef_QBS(i,k)
+        Dcoef_QBS_out(i,k) = Dcoef_QBS(i,k)
+        Kcoef_qbs_out(i,k) = Kcoefqbs(i,k)
+          IF (k.eq.1) THEN
+            gama_qbs_out(i,k)  = 0.
+          ELSE
+            gama_qbs_out(i,k)  = gamaqbs(i,k)
+          ENDIF
+      ENDDO
+    ENDDO
+!!!      
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
+!!!
+
+  END SUBROUTINE climb_qbs_down
+!
+!****************************************************************************************
+!
+  SUBROUTINE calc_coef_qbs(knon, Kcoef, gama, delp, X, Ccoef, Dcoef, Acoef, Bcoef)
+!
+! Calculate the coefficients C and D in : X(k) = C(k) + D(k)*X(k-1)
+! where X is QQBS, and k the vertical level k=1,klev
+!
+    INCLUDE "YOMCST.h"
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN)                      :: knon
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: Kcoef, delp
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: X
+    REAL, DIMENSION(klon,2:klev), INTENT(IN) :: gama
+
+! Output arguments
+!****************************************************************************************
+    REAL, DIMENSION(klon), INTENT(OUT)       :: Acoef, Bcoef
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: Ccoef, Dcoef
+
+! Local variables
+!****************************************************************************************
+    INTEGER                                  :: k, i
+    REAL                                     :: buf
+
+!****************************************************************************************
+! Niveau au sommet, k=klev
+!
+!****************************************************************************************
+    Ccoef(:,:) = 0.0
+    Dcoef(:,:) = 0.0
+
+    DO i = 1, knon
+       buf = delp(i,klev) + Kcoef(i,klev)
+       
+       Ccoef(i,klev) = (X(i,klev)*delp(i,klev) - Kcoef(i,klev)*gama(i,klev))/buf
+       Dcoef(i,klev) = Kcoef(i,klev)/buf
+    END DO
+
+
+!****************************************************************************************
+! Niveau  (klev-1) <= k <= 2
+!
+!****************************************************************************************
+
+    DO k=(klev-1),2,-1
+       DO i = 1, knon
+          buf = delp(i,k) + Kcoef(i,k) + Kcoef(i,k+1)*(1.-Dcoef(i,k+1))
+          Ccoef(i,k) = (X(i,k)*delp(i,k) + Kcoef(i,k+1)*Ccoef(i,k+1) + &
+               Kcoef(i,k+1)*gama(i,k+1) - Kcoef(i,k)*gama(i,k))/buf
+          Dcoef(i,k) = Kcoef(i,k)/buf
+       END DO
+    END DO
+
+!****************************************************************************************
+! Niveau k=1
+!
+!****************************************************************************************
+
+    DO i = 1, knon
+       buf = delp(i,1) + Kcoef(i,2)*(1.-Dcoef(i,2))
+       Acoef(i) = (X(i,1)*delp(i,1) + Kcoef(i,2)*(gama(i,2)+Ccoef(i,2)))/buf
+       Bcoef(i) = -1. * RG / buf
+    END DO
+
+  END SUBROUTINE calc_coef_qbs
+!
+!****************************************************************************************
+!
+  SUBROUTINE climb_qbs_up(knon, dtime, qbs_old, &
+       flx_qbs1, paprs, pplay, &
+       Acoef_QBS_in, Bcoef_QBS_in, &
+       Ccoef_QBS_in, Dcoef_QBS_in, &
+       Kcoef_qbs_in, gama_qbs_in, &
+       flux_qbs, d_qbs)
+! 
+! This routine calculates the flux and tendency of the specific content of blowing snow qbs 
+! The quantity qbs is calculated according to 
+! X(k) = C(k) + D(k)*X(k-1) for X=[qbs], where the coefficients 
+! C and D are known from before and k is index of the vertical layer.
+!   
+
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN)                      :: knon
+    REAL, INTENT(IN)                         :: dtime
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: qbs_old
+    REAL, DIMENSION(klon), INTENT(IN)        :: flx_qbs1
+    REAL, DIMENSION(klon,klev+1), INTENT(IN) :: paprs
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: pplay
+
+!!! nrlmd le 02/05/2011
+    REAL, DIMENSION(klon), INTENT(IN)        :: Acoef_QBS_in, Bcoef_QBS_in
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: Ccoef_QBS_in, Dcoef_QBS_in
+    REAL, DIMENSION(klon,klev), INTENT(IN)   :: Kcoef_qbs_in, gama_qbs_in
+!!!
+
+! Output arguments
+!****************************************************************************************
+    REAL, DIMENSION(klon,klev), INTENT(OUT)  :: flux_qbs, d_qbs
+
+! Local variables
+!****************************************************************************************
+    LOGICAL, SAVE                            :: last=.FALSE.
+    REAL, DIMENSION(klon,klev)               :: qbs_new
+    REAL, DIMENSION(klon)                    :: psref         
+    INTEGER                                  :: k, i, ierr
+ 
+! Include
+!****************************************************************************************
+    INCLUDE "YOMCST.h"
+    INCLUDE "compbl.h"    
+
+!****************************************************************************************
+! 1) 
+! Definition of some variables
+    REAL, DIMENSION(klon,klev)               :: zairm
+!
+!****************************************************************************************
+    flux_qbs(:,:) = 0.0
+    d_qbs(:,:)    = 0.0
+
+    psref(1:knon) = paprs(1:knon,1)  
+
+       IF (mod(iflag_pbl_split,10) .ge.1) THEN
+    DO i = 1, knon
+      Acoef_QBS(i)=Acoef_QBS_in(i)
+      Bcoef_QBS(i)=Bcoef_QBS_in(i)
+    ENDDO
+    DO k = 1, klev
+      DO i = 1, knon
+        Ccoef_QBS(i,k)=Ccoef_QBS_in(i,k)
+        Dcoef_QBS(i,k)=Dcoef_QBS_in(i,k)
+        Kcoefqbs(i,k)=Kcoef_qbs_in(i,k)
+          IF (k.gt.1) THEN
+            gamaqbs(i,k)=gama_qbs_in(i,k)
+          ENDIF
+      ENDDO
+    ENDDO
+!!!      
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
+!!!
+
+!****************************************************************************************
+! 2)
+! Calculation of QBS
+!
+!****************************************************************************************
+
+!- First layer
+    qbs_new(1:knon,1) = Acoef_QBS(1:knon) + Bcoef_QBS(1:knon)*flx_qbs1(1:knon)*dtime
+!- All the other layers 
+    DO k = 2, klev
+       DO i = 1, knon
+          qbs_new(i,k) = Ccoef_QBS(i,k) + Dcoef_QBS(i,k)*qbs_new(i,k-1)
+       END DO
+    END DO
+!****************************************************************************************
+! 3)
+! Calculation of the flux for QBS
+!
+!****************************************************************************************
+
+!- The flux at first layer, k=1
+    flux_qbs(1:knon,1)=flx_qbs1(1:knon)
+
+!- The flux at all layers above surface
+    DO k = 2, klev
+       DO i = 1, knon
+          flux_qbs(i,k) = (Kcoefqbs(i,k)/RG/dtime) * &
+               (qbs_new(i,k)-qbs_new(i,k-1)+gamaqbs(i,k))
+       END DO
+    END DO
+
+!****************************************************************************************
+! 4)
+! Calculation of tendency for QBS
+!
+!****************************************************************************************
+    DO k = 1, klev
+       DO i = 1, knon
+          d_qbs(i,k) = qbs_new(i,k) - qbs_old(i,k)
+          zairm(i, k) = (paprs(i,k)-paprs(i,k+1))/rg
+        END DO
+    END DO
+
+!****************************************************************************************
+! Some deallocations
+!
+!****************************************************************************************
+    IF (last) THEN
+       DEALLOCATE(Ccoef_QBS, Dcoef_QBS,stat=ierr)    
+       IF ( ierr /= 0 )  PRINT*,' pb in dealllocate Ccoef_QBS, Dcoef_QBS, ierr=', ierr
+       DEALLOCATE(Acoef_QBS, Bcoef_QBS,stat=ierr)    
+       IF ( ierr /= 0 )  PRINT*,' pb in dealllocate Acoef_QBS, Bcoef_QBS, ierr=', ierr
+       DEALLOCATE(gamaqbs,stat=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in dealllocate gamaqbs, ierr=', ierr
+       DEALLOCATE(Kcoefqbs,stat=ierr)
+       IF ( ierr /= 0 )  PRINT*,' pb in dealllocate Kcoefqbs, ierr=', ierr
+    END IF
+  END SUBROUTINE climb_qbs_up
+!
+!****************************************************************************************
+!
+END MODULE climb_qbs_mod
+
+ 
+
+
+
+
